<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @tree-load="treeLoad"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.categoryinfo_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, getByParentId} from "@/api/mall/categoryinfo";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          lazy: true,
          rowKey: 'id',
          column: [
            {
              label: "分类名称",
              prop: "title",
              rules: [{
                required: true,
                message: "请输入分类名称",
                trigger: "blur"
              }]
            },
            {
              label: "层级",
              prop: "level",
              hide: true,
              addDisplay: false,
              viewDisplay: false,
              editDisplay: false,
              value: 0,
              rules: [{
                required: true,
                message: "请输入层级",
                trigger: "blur"
              }]
            },
            {
              label: "状态",
              prop: "state",
              rules: [{
                required: true,
                message: "请输入状态",
                trigger: "blur"
              }],
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=state",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
            },
            {
              label: "排序",
              prop: "sort",
              rules: [{
                required: true,
                message: "请输入排序",
                trigger: "blur"
              }]
            },
            {
              label: "分类图标",
              prop: "logoShow",
              addDisplay: false,
              viewDisplay: false,
              editDisplay: false,
              type: 'upload',
              listType: 'picture-img',
            },
            {
              label: "分类父",
              prop: "parentId",
              type: "select",
              hide: true,
              // addDisplay: false,
              viewDisplay: false,
              editDisplay: false,
              // value: 0,
              props: {
                label: 'title',
                value: 'id'
              },
              dicUrl: '/api/mall/categoryinfo/getByParentId/0'
            },
            {
              label: '分类图标',
              prop: 'logo',
              type: 'upload',
              listType: 'picture-img',
              loadText: '上传中，请稍等',
              accept: 'image/png, image/jpeg',
              fileSize: 500,
              tip: '只能上传jpg/png文件，且不超过500kb',
              span: 24,
              hide: true,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/blade-resource/oss/endpoint/put-file-attach"
            },
            {
              label: '选中时的图标',
              prop: 'selectImage',
              type: 'upload',
              listType: 'picture-img',
              loadText: '上传中，请稍等',
              accept: 'image/png, image/jpeg',
              fileSize: 500,
              tip: '只能上传jpg/png文件，且不超过500kb',
              span: 24,
              hide: true,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/blade-resource/oss/endpoint/put-file-attach"
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.categoryinfo_add, false),
          viewBtn: this.vaildData(this.permission.categoryinfo_view, false),
          delBtn: this.vaildData(this.permission.categoryinfo_delete, false),
          editBtn: this.vaildData(this.permission.categoryinfo_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        this.query.parentId = 0;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.data.forEach(e => {
            e.logoShow = e.logo;
            e.hasChildren = true;
          })
          this.loading = false;
          this.selectionClear();
        });
      },
      treeLoad (tree, treeNode, resolve) {
        getByParentId(tree.id).then(res => {
          const data = res.data.data;
          data.forEach(e => {
            e.hasChildren = false;
            e.logoShow = e.logo;
          })
          resolve(data)
        });
      }
    }
  };
</script>

<style>
</style>
